require 'rack'
require 'json'
require 'open-uri'
require 'pretty_proxy'

# the json path below is relative to the Rakefile, call rake or change it
config = JSON.parse(open('example/example_conf.json').read)

pretty_proxy_new_args = config['pretty_proxy_new_args']
proxy_path = pretty_proxy_new_args['proxy_path']
original_domain = pretty_proxy_new_args['original_domain']
original_paths = pretty_proxy_new_args['original_paths']

# replace the constants with the paths without trailing slashs
original_html = config['xhtml_template'].join("\n")
                  .gsub('PROXY_PATH', proxy_path[1..-2])
                  .gsub('ORIGINAL_DOMAIN', original_domain[0..-2])

pp = PrettyProxy.new(proxy_path, original_domain, original_paths)

headers = { 'content-type' => 'application/xhtml+xml',
            'content-encoding' => 'identity',
            'content-length' => original_html.bytesize.to_s }

app = Rack::Builder.new do
  map config['content_path'] do
    run (->(env) { [200, headers, [original_html]] })
  end

  map Pathname.new(proxy_path).join('.' + config['content_path']).to_s do
    run pp
  end
end.to_app

run app

