require 'open-uri'
require 'equivalent-xml'
require 'json'
require 'pretty_proxy'

# the json path below is relative to the Rakefile, call rake or change it
config = JSON.parse(open('example/example_conf.json').read)

# this is ugly, but simple and clear, and this is a example
pretty_proxy_new_args = config['pretty_proxy_new_args']
proxy_path = pretty_proxy_new_args['proxy_path']
original_domain = pretty_proxy_new_args['original_domain']
original_paths = pretty_proxy_new_args['original_paths']

original_url = original_domain + config['content_path']
proxy_url = original_domain + Pathname.new(proxy_path).join('.' + config['content_path']).to_s

describe 'PrettyProxy example' do
  let (:pp) { PrettyProxy.new(proxy_path, original_domain, original_paths) }
  let (:original_page) { open(original_url) }
  let (:proxy_page) { open(proxy_url) }
  it { expect(proxy_page.read).to be_equivalent_to(pp.proxify_html(original_page.read, proxy_url, original_page.content_type)) }
end

